325. Maximum Size Subarray Sum Equals k

Given an array nums and a target value k, find the maximum length of a subarray that sums to k. If there isn't one, return 0 instead.
Example 1:
Given nums = [1, -1, 5, -2, 3], k = 3,
return 4. (because the subarray [1, -1, 5, -2] sums to 3 and is the longest)
Example 2:
Given nums = [-2, -1, 2, 1], k = 1,
return 2. (because the subarray [-1, 2] sums to 1 and is the longest)
Follow Up:
Can you do it in O(n) time?
Note:
The sum of the entire nums array is guaranteed to fit within the 32-bit signed integer range.

这题跟560. subarray sum equals k几乎一毛一样。
我想到了用map和sum - k 来实现ONE PASS,但是不知道怎么维护一个类似560题里面那个count的值了。正确答案是用Math.max每次对比当前maxLen 和 i - map.get(sum-k)。

思维难度还是有的。
这题leetcode收费了。我贴一个别人的答案。注意这里的put始终是put(sum,i),不需要取原来的值。因为我们需要记录sum 相同的最早的值,后面sum - k 在前面map出现过的话,取最出现的那个index就好了。

public class Solution {
    public int maxSubArrayLen(int[] nums, int k) {
        Map hm = new HashMap<>();
        int result = 0, sum = 0;
        hm.put(0, -1);
        for(int i = 0; i < nums.length; i++) {
            sum += nums[i];
            if (hm.containsKey(sum - k)) result = Math.max(i - hm.get(sum - k), result);
            if (!hm.containsKey(sum)) hm.put(sum, i);
        }
        return result;
    }
}

ref:
https://discuss.leetcode.com/topic/33259/o-n-super-clean-9-line-java-solution-with-hashmap

你可能感兴趣的:(325. Maximum Size Subarray Sum Equals k)